| # kio Library API Documentation
Overview | Class Hierarchy | Classes | Classes (annotated) | Members | Source Files

# KTrader Class Reference

A Trader interface, similar to the CORBA Trader. Provides a way to query the KDE infrastructure for specific applications or components. More...

`#include <ktrader.h>`

Inheritance diagram for KTrader:

[legend]
Collaboration diagram for KTrader:

[legend]
List of all members.

## Public Types
typedef QValueList< KService::Ptr > | OfferList
| A list of services.
typedef QValueListIterator< KService::Ptr > | OfferListIterator
## Public Member Functions
virtual | ~KTrader ()
| Standard destructor.
virtual OfferList | query (const QString &servicetype, const QString &constraint=QString::null, const QString &preferences=QString::null) const
| The main function in the KTrader class.
OfferList | query (const QString &servicetype, const QString &genericServiceType, const QString &constraint, const QString &preferences) const
| A variant of query, that takes two service types as an input.
## Static Public Member Functions
KTrader * | self ()
| This is a static pointer to a KTrader instance.
## Protected Member Functions
virtual void | virtual_hook (int id, void *data)

## Detailed Description

A Trader interface, similar to the CORBA Trader. Provides a way to query the KDE infrastructure for specific applications or components.

Basically, it provides a way for an application to query all KDE services (that is, applications and components) that match a specific set of requirements. This allows you to find an application in real-time without you having to hard-code the name and/or path of the application. It is mostly used when you want to do complex queries that KServiceTypeProfile can't handle.

Examples

A few examples will make this a lot more clear.

Say you have an application that will display HTML. In this example, you don't want to link to khtml... and furthermore, you really don't care if the HTML browser is ours or not, as long as it works. The way that you formulate your query as well as the way that you execute the browser depends on whether or not you want the browser to run stand-alone or embedded.

If you want the browser to run standalone, then you will limit the query to search for all services that handle 'text/html' and, furthermore, they must be applications (Type=Application). You then will use KRun::run() to invoke the application. In "trader-speak", this looks like so:

     KTrader::OfferList offers = KTrader::self()->query("text/html", "Type == 'Application'");
     KService::Ptr ptr = offers.first();
     KURL::List lst;
     lst.append("http://www.kde.org/index.html");
     KRun::run(*ptr, lst);

It should be noted that in the above example, using KServiceTypeProfile would be the better choice since you would probably want the preferred service and the trader doesn't take this into account. The trader does allow you to do more complex things, though. Say, for instance, you want to only choose Netscape. You can do it with the constraint: "(Type == 'Application') and (Name == 'Netscape')"

More the likely, though, you will only use the trader for such things as finding components. In our continuing example, we say that we want to load any KParts component that can handle HTML. We will need to use the KLibFactory and KLibLoader to actually do something with our query, then. Our code would look like so:

     KTrader::OfferList offers = KTrader::self()->query("text/html", "'KParts/ReadOnlyPart' in ServiceTypes");
     KService::Ptr ptr = offers.first();
     KLibFactory *factory = KLibLoader::self()->factory( ptr->library() );
     if (factory)
       part = static_cast<KParts::ReadOnlyPart *>(factory->create(this, ptr->name(), "KParts::ReadOnlyPart"));

Please note that when including property names containing arithmetic operators like - or +, then you have to put brackets around the property name, in order to correctly separate arithmetic operations from the name. So for example a constraint expression like X-KDE-Blah < 4 needs to be written as [X-KDE-Blah] < 4 otherwise it could also be interpreted as Substract the numeric value of the property "KDE" and "Blah" from the property "X" and make sure it is less than 4. Instead of the other meaning, make sure that the numeric value of "X-KDE-Blah" is less than 4.

Please read http://developer.kde.org/documentation/library/tradersyntax.html for a more complete description of the trader language syntax.

Author:
  Torben Weis <weis@kde.org>

Definition at line 99 of file ktrader.h.

## Member Typedef Documentation

typedef QValueList<KService::Ptr> KTrader::OfferList

| A list of services. Definition at line 106 of file ktrader.h. Referenced by KIO::PreviewJob::availablePlugins(), KIO::MetaInfoJob::availablePlugins(), KFilterBase::findFilterByMimeType(), KScanDialog::getScanDialog(), KURIFilter::loadPlugins(), query(), KDataToolInfo::query(), KIO::PreviewJob::supportedMimeTypes(), and KIO::MetaInfoJob::supportedMimeTypes().

## Constructor & Destructor Documentation

KTrader::~KTrader | ( |  | ) | `[virtual]`

| Standard destructor. Definition at line 101 of file ktrader.cpp.

## Member Function Documentation

KTrader::OfferList KTrader::query | ( | const QString & | servicetype,
|  | const QString & | constraint = QString::null,
|  | const QString & | preferences = QString::null
| ) | const`[virtual]`

| The main function in the KTrader class. It will return a list of services that match your specifications. The only required parameter is the service type. This is something like 'text/plain' or 'text/html'. The constraint parameter is used to limit the possible choices returned based on the constraints you give it. The constraint language is rather full. The most common keywords are AND, OR, NOT, IN, and EXIST.. all used in an almost spoken-word form. An example is:
     (Type == 'Service') and (('KParts/ReadOnlyPart' in ServiceTypes) or (exist Exec))
  The keys used in the query (Type, ServiceType, Exec) are all fields found in the .desktop files. Parameters:
  servicetype | A service type like 'text/plain', 'text/html', or 'KOfficePlugin'.
  constraint | A constraint to limit the choices returned.
  preferences | Indicates a particular preference to return.
Returns: A list of services that satisfy the query. Definition at line 105 of file ktrader.cpp. References OfferList. Referenced by KIO::PreviewJob::availablePlugins(), KIO::MetaInfoJob::availablePlugins(), KFilterBase::findFilterByMimeType(), KScanDialog::getScanDialog(), KURIFilter::loadPlugins(), KDataToolInfo::query(), KIO::PreviewJob::supportedMimeTypes(), and KIO::MetaInfoJob::supportedMimeTypes().

KTrader::OfferList KTrader::query | ( | const QString & | servicetype,
|  | const QString & | genericServiceType,
|  | const QString & | constraint,
|  | const QString & | preferences
| ) | const

| A variant of query, that takes two service types as an input. It is not exactly the same as adding the second service type in the constraints of the other query call, because this one takes into account user preferences for this combination of service types. Typically, this is used for getting the list of embeddable components that can handle a given mimetype. In that case, `servicetype` is the mimetype and `genericServiceType` is "KParts/ReadOnlyPart". Definition at line 111 of file ktrader.cpp. References QValueList::append(), QValueList::begin(), QValueList::count(), QValueList::end(), QString::isEmpty(), KIO::matchConstraint(), KIO::matchPreferences(), OfferList, KServiceTypeProfile::offers(), QValueList::prepend(), and QValueList::remove().

KTrader * KTrader::self | ( |  | ) | `[static]`

| This is a static pointer to a KTrader instance. You will need to use this to access the KTrader functionality since the constuctors are protected. Returns: Static KTrader instance Definition at line 89 of file ktrader.cpp. Referenced by KIO::PreviewJob::availablePlugins(), KIO::MetaInfoJob::availablePlugins(), KFilterBase::findFilterByMimeType(), KScanDialog::getScanDialog(), KURIFilter::loadPlugins(), KDataToolInfo::query(), KIO::PreviewJob::supportedMimeTypes(), and KIO::MetaInfoJob::supportedMimeTypes().

The documentation for this class was generated from the following files:

- ktrader.h
- ktrader.cpp

This file is part of the documentation for kdelibs Version 3.1.5.
Documentation copyright © 1996-2002 the KDE developers.
Generated on Wed Jan 28 13:23:18 2004 by doxygen 1.3.4 written by Dimitri van Heesch, © 1997-2001